<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  >

    <xsl:template name="hexpairs-to-dec">
      <xsl:param name="pair" select="1"/>
      <xsl:param name="hexval"/>
      <xsl:variable name="hexpair" 
  select="substring($hexval,$pair * 2 - 1,2)"/>
      <xsl:if test="$hexpair">
        <xsl:variable name="hex" select="'0123456789ABCDEF'"/>
        <xsl:value-of 
  select="(string-length(substring-before($hex,
                         substring($hexpair,1,1))))*16 + 
                         string-length(
          substring-before($hex,substring($hexpair,2,1)))"/>
      </xsl:if>
    </xsl:template>
 
			

    <xsl:output method="html" />

<xsl:template match="/">
   <html>
   <body>
   <h2>Code List:</h2>
   <table border="1">

       <tr bgcolor="#9acd32">
         <th>Code</th>
         <th>skip</th>
         <th>Name</th>
         <th>Model</th>
         <th>Colour</th>
         <th>point line</th>
         <th>linestyle</th>
         <th>weight</th>
         <th>comment</th>
         <th>group</th>
       </tr>
 <tr bgcolor="#5FAF62">
	<td>POINT CODES</td>
	<td>&#160;</td>
	<td>&#160;</td>
	<td>&#160;</td>
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
</tr> 
     <xsl:for-each select="*[local-name()='FeatureCodingDefinitions']/*[local-name()='FeatureDefinitions']/*[local-name()='PointFeatureDefinition']">
	
     <tr bgcolor="#A9A9A9">
       <td><xsl:value-of select="@*[local-name()='Code']" /></td>
	   <td></td>
       <td><xsl:value-of select="@*[local-name()='Name']" /></td>
       <td><xsl:value-of select="@*[local-name()='Layer']" /></td>
	   <xsl:variable name="hexval" select="@*[local-name()='Color']"/>
	   <td>
        rgb(
            <xsl:call-template name="hexpairs-to-dec">
              <xsl:with-param name="pair" select="1"/>
              <xsl:with-param name="hexval" select="$hexval"/>
            </xsl:call-template>
			,
            <xsl:call-template name="hexpairs-to-dec">
              <xsl:with-param name="pair" select="2"/>
              <xsl:with-param name="hexval" select="$hexval"/>
            </xsl:call-template>
			,
            <xsl:call-template name="hexpairs-to-dec">
              <xsl:with-param name="pair" select="3"/>
              <xsl:with-param name="hexval" select="$hexval"/>
            </xsl:call-template>
			)
			
			</td>
	   <td>point</td>
	   <td>0</td>

	<td>&#160;</td>
	<td>&#160;</td>
       <td><xsl:value-of select="@*[local-name()='Category']" /></td>
	   
     </tr>
   
 
  
     </xsl:for-each>

 
<tr bgcolor="#5FAF62">
	<td>LINE CODES</td>
	<td>&#160;</td>
	<td>&#160;</td>
	<td>&#160;</td>
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
	<td>&#160;</td> 
</tr>

     <xsl:for-each select="*[local-name()='FeatureCodingDefinitions']/*[local-name()='FeatureDefinitions']/*[local-name()='LineFeatureDefinition']">
	 
     <tr bgcolor="#A9A9A9">
       
	    <td><xsl:value-of select="@*[local-name()='Code']" /></td>
	   <td></td>
       <td><xsl:value-of select="@*[local-name()='Name']" /></td>
       <td><xsl:value-of select="@*[local-name()='Layer']" /></td>
	   <xsl:variable name="hexval2" select="@*[local-name()='Color']"/>
       <td>
        rgb(
            <xsl:call-template name="hexpairs-to-dec">
              <xsl:with-param name="pair" select="1"/>
              <xsl:with-param name="hexval" select="$hexval2"/>
            </xsl:call-template>
			,
            <xsl:call-template name="hexpairs-to-dec">
              <xsl:with-param name="pair" select="2"/>
              <xsl:with-param name="hexval" select="$hexval2"/>
            </xsl:call-template>
			,
            <xsl:call-template name="hexpairs-to-dec">
              <xsl:with-param name="pair" select="3"/>
              <xsl:with-param name="hexval" select="$hexval2"/>
            </xsl:call-template>
			)
			
			</td>
			
	   <td>line</td> 
       <td><xsl:value-of select="@*[local-name()='LineStyleName']" /></td>
       <td><xsl:value-of select="@*[local-name()='LineStyleScale']" /></td> 
	 
	<td>&#160;</td>
       <td><xsl:value-of select="@*[local-name()='Category']" /></td>
	    
     </tr>
  
 
  
     </xsl:for-each>

   </table>
   </body>
   </html>
</xsl:template>

</xsl:stylesheet> 